"
    Copyright (c) 2012-2016 Igor Stasenko
                            Martin McClure
                            Damien Pollet
                            Camillo Bruni
                            Guido Chari
                   2016-now Jan Vrany <jan.vrany [at] fit . cvut . cz>

    Permission is hereby granted, free of charge, to any person obtaining a copy
    of this software and associated documentation files (the 'Software'), to deal
    in the Software without restriction, including without limitation the rights
    to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    copies of the Software, and to permit persons to whom the Software is
    furnished to do so, subject to the following conditions:

    The above copyright notice and this permission notice shall be included in all
    copies or substantial portions of the Software.

    THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    SOFTWARE.
"
"{ Package: 'jv:dragonfly/asm' }"

"{ NameSpace: Smalltalk }"

Object subclass:#AJCallInfo
	instanceVariableNames:'asm stackAlignment stackSize arguments callCleanup prepareForCall
		noCleanup alignInsertionPoint'
	classVariableNames:''
	poolDictionaries:''
	category:'AsmJit-StackManagement'
!

!AJCallInfo class methodsFor:'documentation'!

copyright
"
    Copyright (c) 2012-2016 Igor Stasenko
                            Martin McClure
                            Damien Pollet
                            Camillo Bruni
                            Guido Chari
                   2016-now Jan Vrany <jan.vrany [at] fit . cvut . cz>

    Permission is hereby granted, free of charge, to any person obtaining a copy
    of this software and associated documentation files (the 'Software'), to deal
    in the Software without restriction, including without limitation the rights
    to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    copies of the Software, and to permit persons to whom the Software is
    furnished to do so, subject to the following conditions:

    The above copyright notice and this permission notice shall be included in all
    copies or substantial portions of the Software.

    THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    SOFTWARE.

"
! !

!AJCallInfo class methodsFor:'instance creation'!

new
    "return an initialized instance"

    ^ self basicNew initialize.
! !

!AJCallInfo methodsFor:'accessing'!

alignment: aStackAlignment
    stackAlignment := aStackAlignment
!

alignmentInsertionPoint: instruction
    alignInsertionPoint := instruction
!

asm: assembler
    asm := assembler
!

callCleanup: aCallCleanup
    self assert: callCleanup isNil.
    
    callCleanup := aCallCleanup 
!

defaultArgumentSize
    self subclassResponsibility 
!

disableCleanup 
    noCleanup := true
!

name
    ^ 'call info' 
!

noCleanup 
    ^ noCleanup 
!

noticeArgument: aCallArgument

    arguments add: aCallArgument.
    stackSize := stackSize + aCallArgument size.
!

stackSize
    ^ stackSize
!

stackSize: anObject
    stackSize := anObject
! !

!AJCallInfo methodsFor:'initialize-release'!

initialize
    arguments := OrderedCollection new.
    stackSize := 0.
    stackAlignment := 1.
    noCleanup := false.
! !

!AJCallInfo methodsFor:'pushing args'!

push: anArgument
    
    asm pushArgument: anArgument forCall: self.
! !

!AJCallInfo methodsFor:'testing'!

needsAlignment
    ^ stackAlignment > 1
! !

