"
    Copyright (c) 2012-2016 Igor Stasenko
                            Martin McClure
                            Damien Pollet
                            Camillo Bruni
                            Guido Chari
                   2016-now Jan Vrany <jan.vrany [at] fit . cvut . cz>

    Permission is hereby granted, free of charge, to any person obtaining a copy
    of this software and associated documentation files (the 'Software'), to deal
    in the Software without restriction, including without limitation the rights
    to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    copies of the Software, and to permit persons to whom the Software is
    furnished to do so, subject to the following conditions:

    The above copyright notice and this permission notice shall be included in all
    copies or substantial portions of the Software.

    THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    SOFTWARE.
"
"{ Package: 'jv:dragonfly/asm' }"

"{ NameSpace: Smalltalk }"

AJInstruction subclass:#AJReserveTemp
	instanceVariableNames:'operand size'
	classVariableNames:''
	poolDictionaries:''
	category:'AsmJit-StackManagement'
!

AJReserveTemp comment:'note: assembler should set size even before realizing a temp into stack location reference'
!

!AJReserveTemp class methodsFor:'documentation'!

copyright
"
    Copyright (c) 2012-2016 Igor Stasenko
                            Martin McClure
                            Damien Pollet
                            Camillo Bruni
                            Guido Chari
                   2016-now Jan Vrany <jan.vrany [at] fit . cvut . cz>

    Permission is hereby granted, free of charge, to any person obtaining a copy
    of this software and associated documentation files (the 'Software'), to deal
    in the Software without restriction, including without limitation the rights
    to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    copies of the Software, and to permit persons to whom the Software is
    furnished to do so, subject to the following conditions:

    The above copyright notice and this permission notice shall be included in all
    copies or substantial portions of the Software.

    THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    SOFTWARE.

"
! !

!AJReserveTemp methodsFor:'accessing'!

name
    ^ name ifNil: [ 'Reserve temp' ]
!

operand
    ^ operands first
!

operand: anObject
    anObject annotation: annotation.  
    operands := Array with: anObject 
!

size
    ^ size
!

size: number
    size := number
!

stackSize
    ^ self size
! !

!AJReserveTemp methodsFor:'converting'!

asAJOperand
    
    ^ operands first
! !

!AJReserveTemp methodsFor:'emitting code'!

emitPushOnStack: asm
    ^ asm push: self
! !

!AJReserveTemp methodsFor:'printing'!

printAsOperandOn: aStream
    
    annotation ifNotNil: [
        aStream nextPut: $"; nextPutAll: annotation asString; nextPut: $"; space
    ].

    operands 
        ifNil: [ ^ aStream nextPutAll: 'aStackTEMP' ].
    self operand printAsOperandOn: aStream.
!

printOn: aStream
    ^ self printSelfOn: aStream  
! !

!AJReserveTemp methodsFor:'testing'!

isMem
    ^ true
!

prohibitsRex
"This test is used to validate if operand(s) is valid.. but reserve temp could not have an operand assigned yet and validation 
can be only performed at instruction analyzis stage (right before emitting the code), but not at instruction creation time"
    self flag: #todo. 
    ^ false
! !

!AJReserveTemp methodsFor:'visitor'!

accept: anObject
    ^ anObject reserveTemp: self
!

processTempsWith: anObject
    anObject reserveTemp: self  
! !

