"
    Copyright (c) 2012-2016 Igor Stasenko
                            Martin McClure
                            Damien Pollet
                            Camillo Bruni
                            Guido Chari
                   2016-now Jan Vrany <jan.vrany [at] fit . cvut . cz>

    Permission is hereby granted, free of charge, to any person obtaining a copy
    of this software and associated documentation files (the 'Software'), to deal
    in the Software without restriction, including without limitation the rights
    to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    copies of the Software, and to permit persons to whom the Software is
    furnished to do so, subject to the following conditions:

    The above copyright notice and this permission notice shall be included in all
    copies or substantial portions of the Software.

    THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    SOFTWARE.
"
"{ Package: 'jv:dragonfly/asm' }"

"{ NameSpace: Smalltalk }"

LibraryDefinition subclass:#jv_dragonfly_asm
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'* Projects & Packages *'
!

!jv_dragonfly_asm class methodsFor:'documentation'!

copyright
"
    Copyright (c) 2012-2016 Igor Stasenko
                            Martin McClure
                            Damien Pollet
                            Camillo Bruni
                            Guido Chari
                   2016-now Jan Vrany <jan.vrany [at] fit . cvut . cz>

    Permission is hereby granted, free of charge, to any person obtaining a copy
    of this software and associated documentation files (the 'Software'), to deal
    in the Software without restriction, including without limitation the rights
    to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    copies of the Software, and to permit persons to whom the Software is
    furnished to do so, subject to the following conditions:

    The above copyright notice and this permission notice shall be included in all
    copies or substantial portions of the Software.

    THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    SOFTWARE.

"
! !

!jv_dragonfly_asm class methodsFor:'description'!

excludedFromPreRequisites
    "list packages which are to be explicitely excluded from the automatic constructed
     prerequisites list. If empty, everything that is found along the inheritance of any of
     my classes is considered to be a prerequisite package."

    ^ #(
    )
!

mandatoryPreRequisites
    "list packages which are mandatory as a prerequisite.
     This are packages containing superclasses of my classes and classes which
     are extended by myself.
     They are mandatory, because we need these packages as a prerequisite for loading and compiling.
     This method is generated automatically,
     by searching along the inheritance chain of all of my classes."

    ^ #(
        #'stx:libbasic'    "ArithmeticValue - extended"
    )
!

referencedPreRequisites
    "list packages which are a prerequisite, because they contain
     classes which are referenced by my classes.
     We do not need these packages as a prerequisite for compiling or loading,
     however, a class from it may be referenced during execution and having it
     unloaded then may lead to a runtime doesNotUnderstand error, unless the caller
     includes explicit checks for the package being present.
     This method is generated automatically,
     by searching all classes (and their packages) which are referenced by my classes."

    ^ #(
    )
!

subProjects
    "list packages which are known as subprojects.
     The generated makefile will enter those and make there as well.
     However: they are not forced to be loaded when a package is loaded;
     for those, redefine requiredPrerequisites."

    ^ #(
    )
! !

!jv_dragonfly_asm class methodsFor:'description - contents'!

classNamesAndAttributes
    "lists the classes which are to be included in the project.
     Each entry in the list may be: a single class-name (symbol),
     or an array-literal consisting of class name and attributes.
     Attributes are: #autoload or #<os> where os is one of win32, unix,..."

    ^ #(
        "<className> or (<className> attributes...) in load order"
        AJAssembler
        AJCallInfo
        AJConstants
        AJGeneratedCode
        AJInstruction
        AJLineStream
        AJRoutineStackManager
        #'jv_dragonfly_asm'
        AJAlignmentInstruction
        AJCdeclCallInfo
        AJData
        AJInstructionDecoration
        AJJumpInstruction
        AJJumpLabel
        AJOperand
        AJReleaseTemps
        AJReserveTemp
        AJRoutineEpilogue
        AJRoutinePrologue
        AJStackInstruction
        AJStdCallCallInfo
        AJx86Instruction
        AJx86Registers
        AJBaseReg
        AJCallArgument
        AJCallCleanup
        AJImmediate
        AJMem
        AJx64Instruction
        AJx86Assembler
        AJx86InstructionDescription
        AJx86JumpInstruction
        AJMMRegister
        AJRegister
        AJx64Assembler
        AJx64InstructionDescription
        AJx64JumpInstruction
        AJx87Register
        AJxMMRegister
        AJx86GPRegister
        AJx64RipRegister
        (AJStackAlignmentTests autoload)
        (AJx86AssemblerTests autoload)
        (AJx64AssemblerTests autoload)
        (AJx86RegisterTests autoload)
    )

    "Modified: / 16-06-2016 / 16:56:05 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

extensionMethodNames
    "lists the extension methods which are to be included in the project.
     Entries are 2-element array literals, consisting of class-name and selector.
     A correponding method with real names must be present in my concrete subclasses
     if it has extensions."

    ^ #(
        Integer asAJOperand
        Integer asByte
        Integer asDoubleWord
        Integer asImm
        Integer asImm16
        Integer asImm32
        Integer asImm8
        Integer asQuadWord
        Integer asTwosComplement:
        Integer asUImm
        Integer asUImm16
        Integer asUImm32
        Integer asUImm8
        Integer asWord
        Integer bin
        Integer isByte
        Integer printAsOperandOn:
        WriteStream asLineStream
        Boolean asBit
        False asBit
        True asBit
    )
! !

!jv_dragonfly_asm class methodsFor:'description - mc'!

monticelloLastMergedVersions
"
Name: AsmJit-Core-MartinMcClure.3
Author: MartinMcClure
Time: 27-01-2013, 04:50:49.940 PM
UUID: 9982488c-43fc-4dda-9213-a95df64e8ed2
Ancestors: AsmJit-Core-CamilloBruni.2                

Name: AsmJit-Operands-CamilloBruni.11
Author: CamilloBruni
Time: 07-05-2013, 02:22:03.301 PM
UUID: 95f351e3-2240-4800-93a2-5bb6cc56b1d7
Ancestors: AsmJit-Operands-MartinMcClure.10  

Name: AsmJit-Instructions-MartinMcClure.6
Author: MartinMcClure
Time: 09-02-2013, 02:51:45.480 PM
UUID: 4e4714c8-5b1f-4152-81e0-134a4be40f50
Ancestors: AsmJit-Instructions-MartinMcClure.5     

Name: AsmJit-StackManagement-IgorStasenko.6
Author: IgorStasenko
Time: 13-08-2013, 01:53:04.489 PM
UUID: 72e67d90-f55f-4a34-a7b7-fb2b4c8169d2
Ancestors: AsmJit-StackManagement-IgorStasenko.5    

Name: AsmJit-Extension-MartinMcClure.6
Author: MartinMcClure
Time: 20-01-2013, 08:12:25.519 PM
UUID: 56883179-b4b2-4bd4-8455-d0b8c79822ec
Ancestors: AsmJit-Extension-IgorStasenko.4

Name: AsmJit-x86-IgorStasenko.26
Author: IgorStasenko
Time: 13-08-2013, 01:52:03.480 PM
UUID: 67677e97-32c1-482f-8498-ec6d1e197e60
Ancestors: AsmJit-x86-IgorStasenko.25 

Name: AsmJit-Tests-MartinMcClure.13
Author: MartinMcClure
Time: 30-01-2013, 10:05:01.183 PM
UUID: 28a52f9e-6d3c-4e76-8fca-373630481248
Ancestors: AsmJit-Tests-MartinMcClure.12     


"

    "Created: / 16-12-2015 / 00:05:10 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!jv_dragonfly_asm class methodsFor:'description - project information'!

companyName
    "Returns a company string which will appear in <lib>.rc.
     Under win32, this is placed into the dlls file-info"

    ^ 'My Company'
!

description
    "Returns a description string which will appear in nt.def / bc.def"

    ^ 'Class Library'
!

legalCopyright
    "Returns a copyright string which will appear in <lib>.rc.
     Under win32, this is placed into the dlls file-info"

    ^ 'My CopyRight or CopyLeft'
!

productName
    "Returns a product name which will appear in <lib>.rc.
     Under win32, this is placed into the dlls file-info.
     This method is usually redefined in a concrete application definition"

    ^ 'LibraryName'
! !

!jv_dragonfly_asm class methodsFor:'documentation'!

version_HG
    ^ '$Changeset: <not expanded> $'
! !

